
//////////////////////////////////////////
//  15.6.2002                           //
//  Soutezici 39                        //
//  testovano na simpsonech             //
//////////////////////////////////////////

unit f_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, StdCtrls;

type
  TPohlavi = (Muz, Zena); //copak to asi bude...

  {PClovek = ^TClovek; //pointer na tridu pro uchovani informaci o cloveku
  TClovek = record
    ID: string[10];
    Jmeno: string[32];
    Prijmeni: string[32];
    Pohlavi: TPohlavi;
    Narozeni: Integer;
    Umrti: Integer;
    Matka: PClovek;
    Otec: PClovek;
    ItemIndex: Integer; //cislo polozky v listboxu
  end;}

  TClovek = record //pointer na trida pro uchovani informaci o cloveku
    ID: string[10];
    Jmeno: string[32];
    Prijmeni: string[32];
    Pohlavi: TPohlavi;
    Narozeni: Integer;
    Umrti: Integer;
    Matka: string[10];
    Otec: string[10];
    ItemIndex: Integer; //cislo polozky v listboxu
    RodicIndex: Integer; //cislo polozky v seznamu rodicu
  end;

  TfrmMain = class(TForm)
    lstVypis: TListBox;
    ediID: TEdit;
    ediJmeno: TEdit;
    ediPrijmeni: TEdit;
    ediNarozeni: TEdit;
    ediUmrti: TEdit;
    cmbMatka: TComboBox;
    cmbOtec: TComboBox;
    cmbPohlavi: TComboBox;
    MainMenu: TMainMenu;
    Soubor1: TMenuItem;
    Otevrit1: TMenuItem;
    Ulozit1: TMenuItem;
    N1: TMenuItem;
    Konec1: TMenuItem;
    OpenDialog: TOpenDialog;
    Clovek1: TMenuItem;
    Pridej1: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Vymaz1: TMenuItem;
    btnMatka: TButton;
    btnOtec: TButton;
    btnDrahaPolovicka: TButton;
    SaveDialog: TSaveDialog;
    procedure VymazID(Sender: TObject); //vymaze vypis ID
    procedure PrekresliVystup; //prekresli cely rodokmen
    procedure PridejCloveka(IndexVRodokmenu : Integer); //prikresli cloveka
    procedure NajdiZaznamID(ID : string; var Hledany : TClovek); //najde v rodokmenu cloveka podle ID
    procedure NajdiZaznamII(ItemIndex : Integer; var Hledany : TClovek); //najde v rodokmenu cloveka podle ItemIndexu
    procedure NajdiZaznamM(Matka : string; var Hledany : TClovek); //najde v rodokmenu cloveka podle matky
    procedure NajdiZaznamO(Otec : string; var Hledany : TClovek); //najde v rodokmenu cloveka podle otce
    procedure FormCreate(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure lstVypisClick(Sender: TObject);
    procedure Otevrit1Click(Sender: TObject);
    procedure Pridej1Click(Sender: TObject);
    procedure PrectiRadek(var InputFile: TextFile; var Line: string);
    procedure Vymaz1Click(Sender: TObject);
    procedure btnMatkaClick(Sender: TObject);
    procedure btnOtecClick(Sender: TObject);
    procedure btnDrahaPolovickaClick(Sender: TObject);
    procedure Ulozit1Click(Sender: TObject); //procedura na nacteni jednoho radku z XML, nechapu, proc to nema normalni konce radku ale nejaky #$A
  private
    { Private declarations }
  public
    Rodokmen: array of TClovek;
    intPocetLidiVRod: Integer; //delka pole s rodokmeny
    intMaxID: Int64;
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  intPocetLidiVRod := 0;
  intMaxID := 0;
  cmbPohlavi.ItemIndex := 0;
end;

procedure TfrmMain.Konec1Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.PrekresliVystup;
var i: Integer;
begin
  lstVypis.Items.Clear;
  cmbMatka.Items.Clear;
  cmbOtec.Items.Clear;
  for i := 0 to intPocetLidiVRod-1 do
  begin
    PridejCloveka(i);
  end;
end;

procedure TfrmMain.PridejCloveka(IndexVRodokmenu : Integer);
begin
  Rodokmen[IndexVRodokmenu].ItemIndex := lstVypis.Items.Count;
  lstVypis.Items.Add(Rodokmen[IndexVRodokmenu].Prijmeni + ' ' + Rodokmen[IndexVRodokmenu].Jmeno{ + ' (' + Rodokmen[IndexVRodokmenu].ID + ')'});
  if Rodokmen[IndexVRodokmenu].Pohlavi = Zena then
  begin
    Rodokmen[IndexVRodokmenu].RodicIndex := cmbMatka.Items.Count;
    cmbMatka.Items.Add(Rodokmen[IndexVRodokmenu].Prijmeni + ' ' + Rodokmen[IndexVRodokmenu].Jmeno)
  end
  else
  begin
    Rodokmen[IndexVRodokmenu].RodicIndex := cmbOtec.Items.Count;
    cmbOtec.Items.Add(Rodokmen[IndexVRodokmenu].Prijmeni + ' ' + Rodokmen[IndexVRodokmenu].Jmeno);
  end;
end;

procedure TfrmMain.lstVypisClick(Sender: TObject);
var Rodic : TClovek;
begin
  //vyplnime udaje o cloveku
  ediID.Text := Rodokmen[lstVypis.ItemIndex].ID;
  ediJmeno.Text := Rodokmen[lstVypis.ItemIndex].Jmeno;
  ediPrijmeni.Text := Rodokmen[lstVypis.ItemIndex].Prijmeni;
  cmbPohlavi.ItemIndex := Integer(Rodokmen[lstVypis.ItemIndex].Pohlavi);
  ediNarozeni.Text := IntToStr(Rodokmen[lstVypis.ItemIndex].Narozeni);
  ediUmrti.Text := IntToStr(Rodokmen[lstVypis.ItemIndex].Umrti);
  NajdiZaznamID(Rodokmen[lstVypis.ItemIndex].Matka, Rodic);
  if Rodic.ID <> 'no' then cmbMatka.ItemIndex := Rodic.RodicIndex
  else cmbMatka.ItemIndex := -1;
  NajdiZaznamID(Rodokmen[lstVypis.ItemIndex].Otec, Rodic);
  if Rodic.ID <> 'no' then cmbOtec.ItemIndex := Rodic.RodicIndex
  else cmbOtec.ItemIndex := -1;
  //zpristupnime prochazeni
  btnMatka.Enabled := True;
  btnOtec.Enabled := True;
  btnDrahaPolovicka.Enabled := True;
end;

procedure TfrmMain.VymazID(Sender: TObject);
begin
  ediID.Text := 'I(-1)';
end;

procedure TfrmMain.Otevrit1Click(Sender: TObject);
var
  InputFile: TextFile;
  strRadek: string;
  strTag, strInsideTag: string;
  intTmp: Integer;
begin
  if OpenDialog.Execute then
  begin
    AssignFile(InputFile, OpenDialog.FileName);
    Reset(InputFile);
    PrectiRadek(InputFile, strRadek);
    while strRadek <> '</rodokmen>' do
    begin
      if strRadek = '<osoba>' then
      begin
        //zalozim si novy zaznam v poli
        Inc(intPocetLidiVRod, 1);
        SetLength(Rodokmen, intPocetLidiVRod);
        while strRadek <> '</osoba>' do
        begin
          try //kdyby doslo k chybe pri cteni
          if Pos('/>', strRadek) = 0 then //jestlize nemame prazdny radek
          begin
            //zjistim, co mam za tag
            intTmp := Pos('>', strRadek);
            strTag := Copy(strRadek, 0, intTmp);
            //a podle toho priradim nove polozce v poli prislusnou hodnotu
            strInsideTag := Copy(strRadek, intTmp + 1, Pos('</', strRadek) - intTmp - 1);
            if strTag = '<id>' then
            begin
              Rodokmen[intPocetLidiVRod - 1].ID := strInsideTag;
              Delete(strInsideTag, 1, 1);
              if intMaxID < StrToInt(strInsideTag) then intMaxID := StrToInt(strInsideTag);
            end
            else if strTag = '<jmeno>' then
            begin
              Rodokmen[intPocetLidiVRod - 1].Jmeno := strInsideTag;
            end
            else if strTag = '<prijmeni>' then
            begin
              Rodokmen[intPocetLidiVRod - 1].Prijmeni := strInsideTag;
            end
            else if strTag = '<pohlavi>' then
            begin
              if strInsideTag = 'M' then Rodokmen[intPocetLidiVRod - 1].Pohlavi := TPohlavi(0)
              else Rodokmen[intPocetLidiVRod - 1].Pohlavi := TPohlavi(1);
            end
            else if strTag = '<narozeni>' then
            begin
              Rodokmen[intPocetLidiVRod - 1].Narozeni := StrToInt(strInsideTag);
            end
            else if strTag = '<umrti>' then
            begin
              Rodokmen[intPocetLidiVRod - 1].Umrti := StrToInt(strInsideTag);
            end
            else if strTag = '<matka>' then
            begin
              Rodokmen[intPocetLidiVRod - 1].Matka := strInsideTag;
            end
            else if strTag = '<otec>' then
            begin
              Rodokmen[intPocetLidiVRod - 1].Otec := strInsideTag;
            end;
          end;
          except
            on EConvertError do ShowMessage('Chyba ve zdrojovem souboru, po potvrzeni hlasky bude nacitani normalne pokracovat');
          end;
          PrectiRadek(InputFile, strRadek);
        end;
      end;
      PrectiRadek(InputFile, strRadek);
    end;
    CloseFile(InputFile);
    PrekresliVystup;
    Otevrit1.Enabled := False;
  end;
end;

procedure TfrmMain.Pridej1Click(Sender: TObject);
var i: Integer;
begin
  Inc(intPocetLidiVRod, 1);
  SetLength(Rodokmen, intPocetLidiVRod);
  inc(intMaxID, 1);
  Rodokmen[intPocetLidiVRod - 1].ID := 'I' + IntToStr(intMaxID);
  Rodokmen[intPocetLidiVRod - 1].Jmeno := ediJmeno.Text;
  Rodokmen[intPocetLidiVRod - 1].Prijmeni := ediPrijmeni.Text;
  Rodokmen[intPocetLidiVRod - 1].Pohlavi := TPohlavi(cmbPohlavi.ItemIndex);
  Rodokmen[intPocetLidiVRod - 1].Narozeni := StrToInt(ediNarozeni.Text);
  Rodokmen[intPocetLidiVRod - 1].Umrti := StrToInt(ediUmrti.Text);
  for i := 0 to intPocetLidiVRod - 1 do
  begin
    if (Rodokmen[i].RodicIndex = cmbMatka.ItemIndex) and (Rodokmen[i].Pohlavi = Zena) then
    begin
      Rodokmen[intPocetLidiVRod - 1].Matka := Rodokmen[i].ID;
      Break;
    end;
  end;
  for i := 0 to intPocetLidiVRod - 1 do
  begin
    if (Rodokmen[i].RodicIndex = cmbOtec.ItemIndex) and (Rodokmen[i].Pohlavi = Muz) then
    begin
      Rodokmen[intPocetLidiVRod - 1].Otec := Rodokmen[i].ID;
      Break;
    end;
  end;
  PrekresliVystup;
end;

procedure TfrmMain.PrectiRadek(var InputFile: TextFile; var Line: string);
var Pismeno: Char;
begin
  Line := '';
  repeat
    Read(InputFile, Pismeno);
    Line := Line + Pismeno;
  until (Pismeno = #$A) or EOF(InputFile);
  Delete(Line, Length(Line), 1);
  if EOF(InputFile) then Line := '</rodokmen>';
  Line := Trim(Line);
end;

procedure TfrmMain.Vymaz1Click(Sender: TObject);
var
  Clovek: TClovek;
  i, j: Integer;
begin
  if lstVypis.ItemIndex <> -1 then
  begin
    //najdu zaznam vybraneho cloveka
    NajdiZaznamII(lstVypis.ItemIndex, Clovek);
    if Clovek.ID = 'no' then ShowMessage('Neznama chyba')
    else
    begin
      for i := 0 to intPocetLidiVRod - 1 do
      begin
        //zjistim index vybraneho v poli Rodokmenu
        if Rodokmen[i].ID = Clovek.ID then
        begin
          //preskupim pole
          for j := i to intPocetLidiVRod - 1 do
          begin
            Rodokmen[j] := Rodokmen[j + 1];
          end;
          Dec(intPocetLidiVRod, 1);
          SetLength(Rodokmen, intPocetLidiVRod);
        end;
      end;
      PrekresliVystup;
    end;
  end
  else ShowMessage('Vyber cloveka');
end;

procedure TfrmMain.NajdiZaznamID(ID : string; var Hledany : TClovek);
var
  i: Integer;
begin
  for i := 0 to intPocetLidiVRod - 1 do
  begin
    if Rodokmen[i].ID = ID then
    begin
      Hledany := Rodokmen[i];
      Exit;
    end;
  end;
  Hledany.ID := 'no';
end;

procedure TfrmMain.NajdiZaznamII(ItemIndex : Integer; var Hledany : TClovek);
var
  i: Integer;
begin
  for i := 0 to intPocetLidiVRod - 1 do
  begin
    if Rodokmen[i].ItemIndex = ItemIndex then
    begin
      Hledany := Rodokmen[i];
      Exit;
    end;
  end;
  Hledany.ID := 'no';
end;

procedure TfrmMain.NajdiZaznamM(Matka : string; var Hledany : TClovek);
var
  i: Integer;
begin
  for i := 0 to intPocetLidiVRod - 1 do
  begin
    if Rodokmen[i].Matka = Matka then
    begin
      Hledany := Rodokmen[i];
      Exit;
    end;
  end;
  Hledany.ID := 'no';
end;

procedure TfrmMain.NajdiZaznamO(Otec : string; var Hledany : TClovek);
var
  i: Integer;
begin
  for i := 0 to intPocetLidiVRod - 1 do
  begin
    if Rodokmen[i].Otec = Otec then
    begin
      Hledany := Rodokmen[i];
      Exit;
    end;
  end;
  Hledany.ID := 'no';
end;

procedure TfrmMain.btnMatkaClick(Sender: TObject);
var Dite, Matka: TClovek;
begin
  NajdiZaznamII(lstVypis.ItemIndex, Dite);
  NajdiZaznamID(Dite.Matka, Matka);
  if Matka.ID <> 'no' then lstVypis.ItemIndex := Matka.ItemIndex
  else ShowMessage('Nenalezena');
  lstVypisClick(Self);
end;

procedure TfrmMain.btnOtecClick(Sender: TObject);
var Dite, Otec: TClovek;
begin
  NajdiZaznamII(lstVypis.ItemIndex, Dite);
  NajdiZaznamID(Dite.Otec, Otec);
  if Otec.ID <> 'no' then lstVypis.ItemIndex := Otec.ItemIndex
  else ShowMessage('Nenalezen');
  lstVypisClick(Self);
end;

procedure TfrmMain.btnDrahaPolovickaClick(Sender: TObject);
var Rodic1, Rodic2, Dite: TClovek;
begin
  NajdiZaznamII(lstVypis.ItemIndex, Rodic1);
  if Rodic1.Pohlavi = Muz then
  begin
    NajdiZaznamO(Rodic1.ID, Dite);
    NajdiZaznamID(Dite.Matka, Rodic2);
    if Rodic2.ID <> 'no' then lstVypis.ItemIndex := Rodic2.ItemIndex
    else ShowMessage('Nenalezena');
  end
  else
  begin
    NajdiZaznamM(Rodic1.ID, Dite);
    NajdiZaznamID(Dite.Otec, Rodic2);
    if Rodic2.ID <> 'no' then lstVypis.ItemIndex := Rodic2.ItemIndex
    else ShowMessage('Nenalezen');
  end;
  lstVypisClick(Self);
end;

procedure TfrmMain.Ulozit1Click(Sender: TObject);
var OutputFile: TextFile;
begin
  //nestiham naimplementovat...
  if SaveDialog.Execute then
  begin
  end;
end;

end.

